jQuery(document).ready(function(jQuery){
    jQuery('[id^="image_button"]').click(function(e) {
        e.preventDefault();
        frame = wp.media({
            title : 'Add your title here',
            frame: 'post',
            state: 'gallery-edit',
            multiple : true, // set to false if you want only one image
            library : { type : 'image'},
            button : { text : 'Add Image' },
        });
       
        frame.on( 'open', function() {
            var images = jQuery( '[id^="imageurls"]' ).val();
            if ( !images )
                return;
            var m = images.match(/(\d.*\d)/);
            var image_ids = m[1].split( ',' );
            var library = frame.state().get( 'library' );
            image_ids.forEach( function( id ) {
                attachment = wp.media.attachment( id );
                attachment.fetch();
                library.add( attachment ? [ attachment ] : [] );
            } );
            frame.setState('gallery');
            frame.setState('gallery-edit');
        });

        frame.on('close',function(data) {
            var imageArray = [];
            images = frame.state().get('selection');
            if (images) {
                images.each(function(image) {
                    imageArray.push(image.attributes.id);
                });
            }
            if (imageArray.join(",")) {
                jQuery('[id^="imageurls"]').val('[gallery ids="' + imageArray.join(",") + '" size="gallery-thumbnail"]'); // Adds all image URL's comma separated to a text input
            }
        });  
         
        frame.on('update',function(data) {
            var imageArray = [];
            var gallery = imageArray.join(",");
            if (!gallery ) {
                images = frame.state().get('library');
                console.log(images);
                if(images.length < 30){
                    images.each(function(image) {
                        imageArray.push(image.attributes.id);
                        //console.log(imageArray);
                    });
                }
            }

            jQuery('[id^="imageurls"]').val('[gallery ids="' + imageArray.join(",") + '" size="gallery-thumbnail"]'); // Adds all image URL's comma separated to a text input
        });
        frame.open()
    });

    jQuery('[id^="edit_image_button"]').click(function(e) {
        e.preventDefault();
        var gallery_state = 'gallery-edit';
        frame = wp.media({
            title : 'Add your title here',
            frame: 'post',
            state: gallery_state,
            multiple : true, // set to false if you want only one image
            library : { type : 'image'},
            button : { text : 'Edit Image' },
        });
        // when open media frame, add the selected image to Gallery
        frame.on( 'open', function() {
            var images = jQuery( '[id^="imageurls"]' ).val();
            if ( !images )
                return;
            var m = images.match(/(\d.*\d)/);
            var image_ids = m[1].split( ',' );
            var library = frame.state().get( 'library' );
            image_ids.forEach( function( id ) {
                attachment = wp.media.attachment( id );
                attachment.fetch();
                library.add( attachment ? [ attachment ] : [] );
            } );
            frame.setState('gallery');
            frame.setState('gallery-edit');
        });
        frame.on('update', function() {
            var imageArray = [];
            images = frame.state().get('selection');
            if (images) {
                images.each(function(image) {
                //imageArray.push(image.attributes.url); // want other attributes? Check the available ones with console.log(image.attributes);
                //console.log(image.attributes);
                    imageArray.push(image.attributes.id);
                });
            }
            var gallery = imageArray.join(",");
            if (!gallery) {
                images = frame.state().get('library');
                images.each(function(image) {
                    imageArray.push(image.attributes.id);
                });
            }
            jQuery('[id^="imageurls"]').val('[gallery ids="' + imageArray.join(",") + '" size="gallery-thumbnail"]'); // Adds all image URL's comma separated to a text input
        });
        frame.open()
    });
});

jQuery(document).ready(function($){
    var $myText = jQuery('[id^="imageurls"]');
    $myText.data("value", $myText.val());
    setInterval(function() {
        var data = $myText.data("value"),
        val = $myText.val();

        if (data !== val) {
            $myText.data("value", val);
            var images = jQuery( '[id^="imageurls"]' ).val();
            jQuery.post(
                ajaxurl, 
                {
                    action : 'ps_get_gallery',
                    "gallery_ids": images,
                }, 
                function( response ) 
                {
                    jQuery('#admin-gallery').html( response );
                }
            );
        }
    }, 100);    
});